# typescript-node-scripts

## Requirements

-   node `>=6.0.0`
-   yarn

**Note: npm is not supported at this stage for running and building, only bootstrapping is supported.**

## Getting Started

To create a new TypeScript + Node.js based app, run:

```sh
# run
npx typescript-node-scripts initApp <appName>

# get into the folder
cd <appName>

# go!
yarn start
```

## Commands

### `yarn start`

Starts the development server with watch mode and incremental builds. This command generates a bundle which is located at `build/bundle.js`.

#### Options

| Argument          | Description                                                                                        |
| ----------------- | -------------------------------------------------------------------------------------------------- |
| `--no-collapse`   | Expands all the collapsed errors                                                                   |
| `--no-auto-start` | Disables auto starting and stopping of the application. By default, it executes `build/bundle.js`. |

### `yarn build`

Builds a production ready bundle. This minifies all sources into one simple, distribuitable `dist/bundle.prod.js` which is ideal for Docker builds.

This command does not bundle any dependencies which is `require`-d or `import`-ed from `node_modules`!

#### Options

| Argument               | Description                                 |
| ---------------------- | ------------------------------------------- |
| `--no-collapse`        | Expands all the collapsed errors            |
| `--bypass-ci-warnings` | Bypass CI warnings being treated as errors. |

### `yarn test`

Runs the Jest test runners in watch mode by default. You can add in Jest options as usual.

#### Example commands

```sh
yarn test --coverage

yarn test --watchAll
```

## TODO

-   [ ] support `npm` for all scripts in `scripts`
-   [ ] e2e tests
-   [ ] support js, jsx, ts, and tsx files in tests and everything
